/*
 * Copyright (c) 2012 Qualcomm Atheros, Inc..
 * All Rights Reserved.
 * Qualcomm Atheros Confidential and Proprietary.
 */

String.prototype.format = function()
{
    var args = arguments;
    return this.replace(/\{(\d+)\}/g,
        function(m,i){
            return args[i];
        });
}

var elite = window.elite || {};

elite.gConfig = elite.gConfig || {};

elite.gConfig.mask = elite.gConfig.mask || {};

/*--#STATIC--*/
elite.gConfig.mask['System_Ipv6']=1;
/*--#ENDSTATIC--*/
/*--#DYNAMIC>
#FUN(sysMenuMask())#
*//*#ENDDYNAMIC*/

elite.gConfig.modules = {
	system	: [{id : "System_General", 		text : "General",		path: "system_general.htm"},
			   {id : "System_Ip", 			text : "IP",			path: "system_ip.htm"},
			   {id : "System_Ipv6",		    text : "IPv6", 		member: [ {id : "IPv6_Configure",	text : "Configure IPv6", 	path: "system_ipv6.htm"},
			   										                      {id : "IPv6_Address_Configure",	text : "Configure IPv6 Address", path: "system_ipv6_config_address.htm"}]},
			   {id : "System_Upgrade", 		text : "Upgrade",		path: "system_upgrade.htm"},
			   {id : "System_Config_File", 	text : "Configuration File",	path: "system_config_file.htm"},
			   {id : "System_Reset", 		text : "Reset",			path: "system_reset.htm"},
			   {id : "System_Password", 	text : "Password",		path: "system_password.htm"}],

	port	: [{id : "Port_Information",	text : "Information",	path: "port_infor.htm"},
			   {id : "Port_Configuration",	text : "Configuration",	path: "port_config.htm?port=1"},
			   {id : "Port_Statistics",		text : "Statistics",	path: "port_statistics.htm"}],

	vlan	: [{id : "VLAN_Configure_VLAN", 			text : "Configure VLAN",				path: "vlan_config.htm?page=1"},
			   {id : "VLAN_Configure_VLAN_Member",		text : "Configure VLAN Member", 		path: "vlan_member_config.htm?vlan=1"},
			   {id : "VLAN_Configure_If_VLAN",			text : "Configure Interface VLAN",		path: "vlan_if_config.htm"}],

	vvlan	: [{id : "VVLAN_Configure_VVLAN",	text : "Configure Voice VLAN",		path: "vvlan_config.htm"},
			   {id : "VVLAN_Configure_OUI",		text : "Configure OUI",				path: "vvlan_oui_config.htm"},
			   {id : "VVLAN_Show_Port",			text : "Show Port Voice VLAN",		path: "vvlan_port_infor.htm"},
			   {id : "VVLAN_Configure_Port",	text : "Configure Port Voice VLAN",	path: "vvlan_port_config.htm"}],

	mac		: [{id : "MAC_Configure_Static_MAC",		text : "Configure Static MAC",			path: "mac_config_static.htm"},
		 	   {id : "MAC_Search_Delete_Static_MAC",	text : "Search And Delete Static MAC", 	path: "mac_srch_del_static.htm?intf=All&macAddr=&vlan=All"},
			   {id : "MAC_Search_Delete_Dynamic_MAC",	text : "Search And Flush Dynamic MAC", 	path: "mac_show_dynamic.htm?intf=All&macAddr=&vlan=All&page=1"},
			   {id : "MAC_Configure_Dynamic_MAC",		text : "Configure Dynamic MAC",			path: "mac_config_dynamic.htm"},
			   {id : "MAC_Configure_Port",				text : "Configure Port MAC", 			path: "mac_port_config.htm?port=1"}],

	qos		: [{id : "QoS_If_Info",					text : "QoS Interface Information",			path: "qos_if_info.htm"},
			   {id : "QoS_Configure_If",			text : "Configure QoS Interface",			path: "qos_config_if.htm"},
			   {id : "QoS_If_Queue_Info",			text : "QoS Interface Queue Information",	path: "qos_if_queue_info.htm"},
			   {id : "QoS_Configure_If_Queue",		text : "Configure QoS Interface Queue",		path: "qos_if_queue_config.htm"},
			   {id : "QoS_If_CoS_Map_Info",			text : "QoS Interface CoS Map Information",	path: "qos_if_cos_map_info.htm"},
			   {id : "QoS_Configure_If_CoS_Map",	text : "Configure QoS Interface CoS Map",	path: "qos_if_cos_map_config.htm"},
			   {id : "QoS_Dscp_Map_Info",			text : "QoS DSCP Map Information",			path: "qos_dscp_map_info.htm"},
			   {id : "QoS_Configure_Dscp_Map",		text : "Configure QoS DSCP Map", 			path: "qos_dscp_map_config.htm?dscp=0"}],

	trunk	: [{id : "Trunk_Information",				text : "Show Trunk",					path: "trunk_config.htm"},
			   {id : "Trunk_Configure_Trunk_Member",	text : "Configure Trunk Member",		path: "trunk_member_config.htm?trunk=1"},
			   {id : "Trunk_Hash_Mode",	                text : "Configure Trunk Hash Mode",		path: "trunk_hash_mode.htm"}],
	
	multi	: [/*{id : "MCAST_Configure_Static_MAC",		text : "Configure Multicast Static MAC",		path: "mcast_static_mac_config.htm"},*/
			   /*{id : "MCAST_Srch_Del_Static_MAC",	text : "Search And Delete Multicast Static MAC", 	path: "mcast_static_mac_srch_del.htm?intf=All&macAddr=&vlan=All"},*/
			   {id : "IGMP_Snooping",			text : "IGMP Snooping", 		member: [ {id : "IGMP_Snooping_Configure",			text : "Configure IGMP Snooping",	          path: "igmp_snooping.htm"},
			   												  {id : "IGMP_Interface_Configure",         text : "Configure IGMP Snooping Interface",   path: "igmp_config_if.htm"},
															  {id : "IGMP_Interface_Information",       text : "IGMP Snooping Interface Information", path: "igmp_if_info.htm"},
															  {id : "IGMP_Snooping_Table",              text : "Show IGMP Snooping Table",		      path: "igmp_snooping_table.htm"},
															  {id : "IGMP_Querier_Configure",           text : "Configure IGMP Querier",		      path: "igmp_querier.htm"}]}],

	secure 	: [{id : "storm_ctrl",		text: "Storm Control",	member:[{id : "Security_Show_Storm_Control",		text : "Show Storm Control",		path: "security_show_storm_contro.htm"},
																		{id : "Security_Configure_Storm_Control",	text : "Configure Storm Control", 	path: "security_config_storm_control.htm?port=1"}]},
			   {id : "isolation",		text: "Isolation",		member:[{id : "Security_Show_Isol_Group",			text : "Show Isolation Group",		path: "security_show_isol_group.htm"},
			   															{id : "Security_Configure_Isol_Group",		text : "Configure Isolation Group",	path: "security_config_isol_group.htm?group=1"},
			   															{id : "Security_Show_Vlan_Isol",			text : "Show VLAN Isolation",		path: "security_show_vlan_isol.htm"},
			   															{id : "Security_Configure_Vlan_Isol",		text : "Configure VLAN Isolation",  path: "security_config_vlan_isol.htm?vlan=1"}]},
			   {id:  "ddos",            text: "Auto DDos Prevention", path: "security_ddos.htm"}],

	diag	: [{id : "Cable_Diagnostic_Test",	text : "Cable Diagnostic Test",  	path: "diag_cdt.htm?port=1"},
			   {id : "Mirror_Configure",		text : "Mirror", 		member: [ {id : "Mirror_Analyzer_Configure",	text : "Configure Analyzer Interface", 	path: "diag_mirr_analyz_config.htm"},
			   										  {id : "Mirror_Port", 			text : "Configure Mirrored Port", 			path: "diag_port_mirror.htm?port=1"}]},
			   {id : "Loopback_Detection",		text : "Loopback Detection",		path: "diag_loopback.htm"}]
};

elite.UIManager = elite.UIManager || {};

elite.UIManager.show_mask = function()
{
	var div = '<div id="exposeMask" class="opacity20" style="position:absolute; top:0px; left:0px; width:100%; height:100%; display:block; z-index:9998; background-color:#000000;"></div>';

	if ($("#exposeMask").length) {
		$("#exposeMask").show();
	} else {
		$("body").append(div);
	}
}

elite.UIManager.hide_mask = function()
{
	$("#exposeMask").hide();
}

elite.UIManager.create_nav4tab = function(tab)
{

	var nav_ele = "";

	// step1. find module by tab
	var modules_ref = {
		'System' 	: elite.gConfig.modules.system,
		'Port' 		: elite.gConfig.modules.port,
		'VLAN' 		: elite.gConfig.modules.vlan,
		'Voice VLAN': elite.gConfig.modules.vvlan,
		'MAC Address':elite.gConfig.modules.mac,
		'QoS' 		: elite.gConfig.modules.qos,
		'Trunk' 	: elite.gConfig.modules.trunk,
		'Multicast' : elite.gConfig.modules.multi,
		'Security' 	: elite.gConfig.modules.secure,
		'Diagnostic': elite.gConfig.modules.diag
	};

	var nav_t = modules_ref[tab];

	var nav_t_len = nav_t.length;

	// step2. create nav by given module
	for (var i = 0; i < nav_t_len; i ++)
	{
		var item_t = nav_t[i];

		if (elite.gConfig.mask[item_t.id])
		{
			continue;
		}

		if (nav_t[i].member)
		{
			// menu title
			nav_ele += create_nav_title(item_t.id, item_t.text);

			var menu_title = '<div class="menuList" id="' + item_t.id + '">';

			var mem_t = nav_t[i].member;

			var mem_t_len = nav_t[i].member.length;

			for (var j = 0; j < mem_t_len; j ++)
			{
				var mem_item_t = mem_t[j];

				menu_title += create_nav_item(mem_item_t.id, mem_item_t.text, mem_item_t.path);
			}

			menu_title += '</div>';

			nav_ele += menu_title;
		}
		else
		{
			// menu item
			nav_ele += create_nav_item(item_t.id, item_t.text, item_t.path);
		}
	}

	return nav_ele;

	//-------inline function-------
	function create_nav_item(id, text, path)
	{
		var item_tpl = "<a id='{0}' href='{1}' class='menuItem'><img id='{2}' src='{3}' alt=''>{4}</a>";

		path = "config/" + path;

		var img_id = id + "Img";
		var img_src = menu2OrUrl;

		var item = item_tpl.format(id, path, img_id, img_src, text);

		return item;
	}

	function create_nav_title(id, text)
	{
		var item_tpl = "<a id='{0}' href='{1}' class='menuTitle'><img id='{2}' src='{3}' alt=''>{4}</a>";

		var path = "#";

		var img_id = id + "Img";
		var img_src = menu1OrUrl;

		var item = item_tpl.format(id, path, img_id, img_src, text);

		return item;
	}
}

elite.Utils = elite.Utils || {};

elite.Utils.IEVersion = function() {
	var userAgent = window.navigator.userAgent;
	var activeX   = window.ActiveXObject;

	var ieVersion = "NA";
	var ieDocumentMode = "NA";

	if (activeX && /msie/i.test(userAgent))
	{
		var matchArray = userAgent.match( /msie\s*([\d.]+)/i );
		if (matchArray.length > 1)
		{
			ieVersion = parseInt(matchArray[1]);
			ieDocumentMode = document.documentMode;
		}
	}

	return {"Version" : ieVersion, "documentMode" : ieDocumentMode};
}

elite.Utils.initFirstMenu = function(tab) {
	$('#menuTree a.menuItem').click(function(ev) {

		// step1. load page to iframe
		mainIframe.location.replace(this.href);

		// step2. ui update title
		var fth_text = "";
		var $parent = $(this).parent();
		if ($parent.hasClass("menuList")){
			fth_text = $parent.prev().text() + " > ";
		}
		$("#title").html(tab + " > " + fth_text + $(this).text());

		// step3. ui update selected class or img
		$('#menuTree a.selected').removeClass('selected').find("img").attr("src", menu2OrUrl);
		$(this).addClass('selected').find("img").attr("src", menu2SelUrl);

		ev.preventDefault();
	});

	$('#menuTree a.menuTitle').click(function(ev) {
		var img_ele = $(this).find("img");

		if (img_ele.attr("src") == menu1OrUrl){
			img_ele.attr("src", menu1SelUrl);
		} else {
			img_ele.attr("src", menu1OrUrl);
		}

		$(this).next().toggle();
		ev.preventDefault();
	});

	var modules_ref = {
		'System' 	: "System_General",
		'Port' 		: "Port_Information",
		'VLAN' 		: "VLAN_Configure_VLAN",
		'Voice VLAN': "VVLAN_Configure_VVLAN",
		'MAC Address':"MAC_Configure_Static_MAC",
		'QoS' 		: "QoS_If_Info",
		'Trunk' 	: "Trunk_Information",
		'Multicast' : "IGMP_Snooping_Configure",
		'Security' 	: "Security_Show_Storm_Control",
		'Diagnostic': "Cable_Diagnostic_Test"
	};

	$("#" + modules_ref[tab]).trigger("click").parent(".menuList").prev().trigger("click")
}
