/* 
 * Copyright (c) 2012 Qualcomm Atheros, Inc.. 
 * All Rights Reserved. 
 * Qualcomm Atheros Confidential and Proprietary. 
 */

/**********************
 *   draw functions   *
 **********************/
function drawButtons(formId, button)
{
  var str = '';

  var buttonInforArr = button.split('?');
  var buttonType = buttonInforArr[0];

  if (buttonType == 'apply')
  {
    str += '<div class="actButtons">';
    str += '<input class="actButton" type="button" id="applyButton" value="Apply" onclick="' + formId + '.submitForm();">';
    str += '<input class="actButton" type="button" id="revertButton" value="Revert" onclick="init();">';
    str += '<\/div>';
  }
  else if (buttonType == 'delete')
  {
    str += '<div class="actButtons">';
    str += '<input class="actButton" type="button" id="deleteButton" value="Delete" onclick="' + formId + '.submitForm();">';
    str += '<input class="actButton" type="button" id="revertButton" value="Revert" onclick="init();">';
    str += '<\/div>';
  }
  else if (buttonType == 'add')
  {
    str += '<div class="actButtons">';
    str += '<input class="actButton" type="button" id="addButton" value="Add" onclick="' + formId + '.submitForm();">';
    str += '<\/div>';
  }
  else if (buttonType == 'reset')
  {
    var buttonDesc = buttonInforArr[1];
    str += '<div class="exSubmitButton">';
    str += '<input class="actButton" type="button" id="resetButton" value="Reset" onclick="' + formId + '.submitForm();">';
    str += '  ' + buttonDesc;
    str += '<\/div>';
  }
  else if (buttonType == 'save')
  {
    var buttonDesc = buttonInforArr[1];
    str += '<div class="exSubmitButton">';
    str += '<input class="actButton" type="button" id="saveButton" value="Save" onclick="' + formId + '.submitForm();">';
    str += '  ' + buttonDesc;
    str += '<\/div>';
  }
  else if (buttonType == 'default')
  {
    var buttonDesc = buttonInforArr[1];
    str += '<div class="exSubmitButton">';
    str += '<input class="actButton" type="button" id="defaultButton" value="Default" onclick="' + formId + '.submitForm();">';
    str += '  ' + buttonDesc;
    str += '<\/div>';
  }
  else if (buttonType == 'query&flush')
  {
    str += '<div class="actButtons">';
    str += '<input class="actButton" type="button" id="queryButton" value="Query" onclick="' + 'queryForm();">';
    str += '<input class="actButton" type="button" id="flushButton" value="Flush" onclick="' + formId + '.submitForm();">';
    str += '<\/div>';
  }

  return str;
}

function drawCheckBox(id, description, value, onChangeFun)
{
  var str = '<input type="checkbox" name="'+id+'" id="'+id+'"';

  if (onChangeFun)
    str += ' onclick="'+ onChangeFun +'"';

  if ((value == 1) || (value == 'Enabled'))
    str += ' value="1" checked>';
  else
    str += ' value="0">';

  if (description != '')
    str += description;

  return str;
}

function drawSelect(id, size, displayOptionList, valueOptionList, selValue, onChangeFun)
{
  var str = '<select name='+id+' id='+id+' size='+size;

  if (onChangeFun)
  {
    str += ' onchange="'+ onChangeFun +'"';
  }
  str += '>';

  var dArr = displayOptionList.split('?');
  var vArr = valueOptionList.split('?');

  for (var i = 0; (dArr[i] != null) && (vArr[i] != null); i++)
  {
    if ((dArr[i] == '') || (vArr[i] == ''))
    {
      continue;
    }

    str += '<option value='+ vArr[i];
    if (vArr[i] == selValue)
    {
      str += ' selected>';
    }
    else
    {
      str += '>';
    }

    str += dArr[i];
    str += '<\/option>';
  }

  str += '<\/select>';

  return str;
}

function drawInputStr(id, size, max, value)
{
  return '<input type="text" name="'+id+'" id="'+id+'" size="'+size+'" maxlength="'+ max +'" value="'+value+'">';
}

function drawInputIp(id, size, value)
{
  return drawInputStr(id, size, 15, value);
}

function drawInputIpv6(id, size, value)
{
  return drawInputStr(id, size, 41, value);
}

function drawInputHidden(id, value)
{
  var str = '<input type="hidden" name="'+id+'" id="'+id+'" value="'+value+'">';
  return str;
}

function drawInputNum(id, size, max, value)
{
  var maxLength = max.length + 1;
  var str = '<input type="text" name="'+id+'" id="'+id+'" size="'+size+'" maxlength="'+ maxLength +'" value="'+value+'">';
  return str;
}

function drawInputPwd(id, size, maxLength)
{
  var str = '<input type="password" name="'+id+'" id="'+id+'" size="'+size+'" maxlength="'+ maxLength +'" value="">';
  return str;
}

function drawInputMac(id, size, value)
{
  return drawInputStr(id, size, 17, value);
}

function drawInputOui(id, size, value)
{
  return drawInputStr(id, size, 8, value);
}

/***********************
 *   check functions   *
 ***********************/
function checkInputStr(title, str, min, max, spaceVaild)
{
  var args = checkInputStr.arguments;

  for (var i = 0; i < str.length; i++)
  {
    var c = str.charAt(i);

    /* check un-printable char */
    if ((c < ' ') || (c > '~'))
    {
      return title + " contain un-printable character.";
    }

    /* check invalid char */
    if ((c == '?') || (c == '/') || (c == '"') || (c == '\'') ||
        (c == ':') || (c == ';') || (c == ',') || (c == '.') ||
        (c == '[') || (c == ']') || (c == '{') || (c == '}') ||
        (c == '|') || (c == '\\') || (c == '<') || (c == '>'))
    {
      return title + ' contain invalid character ? / " \' : ; , . [ ] { } | \\ < >.';
    }

    /* check space */
    if ((c == ' ') && (spaceVaild == false))
    {
      return title + " cannot contain spaces.";
    }
  }

  /* check string len */
  if ((str.length > max) || (str.length < min))
  {
    return "The length of " + title + " is " + min + "-" + max + ".";
  }

  return "";
}

function checkInputIp(title, ipStr, allZeroValid)
{
    var patternIp     = /^[0-9]{1,3}\.([0-9]{1,3}\.){2}[0-9]{1,3}$/;
    var patternZero   = /^(0){1,3}\.((0){1,3}\.){2}(0){1,3}$/;
	var flag;
    var errorMsg;

	if(0 == ipStr.length)
	{
		errorMsg = "Please input IP address.";
		return errorMsg;
	}

	flag = patternIp.test(ipStr);
	if(!flag)
	{
		errorMsg = "The input IP address is invalid.";
		return errorMsg;
	}

	if(!allZeroValid)
	{
		flag = patternZero.test(ipStr);
		if(flag)
		{
			errorMsg = "The input IP address is invalid(All zero address).";
			return errorMsg;
		}
	}
	
	var szarray = ipStr.split('.');

	for(i = 0; i < 4; i++)
	{
		if (szarray[i] < 0 || szarray[i] > 255)
		{
    		errorMsg = "The input IP address is invalid(0-255).";
    		return errorMsg;
		}
	}
	if(szarray[0]==127) //check loopback address
	{
		errorMsg = "The input IP address is invalid(Loopback address).";
		return errorMsg;
	}
	if(szarray[0] >= 224 && szarray[0] <=239) //check multicast address
	{
		errorMsg = "The input IP address is invalid(Multicast address).";
		return errorMsg;
	}
	return '';
}

function checkInputIpv6(title, ipStr, allZeroValid)
{
	var patternIpv6   = /^([0-9A-Fa-f]{1,4})$/;
	var flag;
    var errorMsg;

	if(0 == ipStr.length)
	{
		errorMsg = "Please input IPv6 address.";
		return errorMsg;
	}
	
    if(ipStr=='::') //check unspecified address
	{
		errorMsg = "The input IPv6 address is invalid(Unpsecified address).";
		return errorMsg;
	}

	if(ipStr=='::1') //check loopback address
	{
		errorMsg = "The input IPv6 address is invalid(Loopback address).";
		return errorMsg;
	}

	var szarray = ipStr.split(':');
	
	if(szarray.length > 8)
	{
		errorMsg = "The input IPv6 address is invalid(too long).";
		return errorMsg;
	}
	
	var zeroCount=0;
	for(var i = 0; i < szarray.length ; i++)
	{
		if(szarray[i] == '')
		{
			zeroCount++;
		}
		else
		{
			flag = patternIpv6.test(szarray[i]);
			if(!flag)
			{
				errorMsg = "The input IPv6 address is invalid.";
				return errorMsg;
			}
		}
	}
	
	if(zeroCount == 0 && szarray.length<8)
	{
		errorMsg = "The input IPv6 address is invalid(too short).";
		return errorMsg;
	}
	if(zeroCount>1)
	{
		errorMsg = "The input IPv6 address is invalid, more than one '::'.";
		return errorMsg;
	}

	if(szarray[0] == 'ffff') //check multicast address
	{
		errorMsg = "The input IPv6 address is invalid(Multicast address).";
		return errorMsg;
	}
	
	if(szarray[0] == 'fe80') //check multicast address
	{
		errorMsg = "The input IPv6 address is invalid(Link-local address).";
		return errorMsg;
	}
		
	return '';
}

function checkInputNum(title, value, min, max, nullValid)
{
  if (value == '')
  {
    if (!nullValid)
    {
        return title + ' is empty.';
    }
    else
    {
        return '';
    }
  }

  if (value.match(/[^0-9]/g))
  {
    return title + ' is not a integer.';
  }

  if ((value < min) || (value > max))
  {
    return 'The value of ' + title + ' is ' + min + '-' + max + '.';
  }

  return '';
}

function checkInputkPwd(title, pwd, min, max, spaceVaild)
{
  return checkInputStr(title, pwd, min, max, spaceVaild);
}

function checkInputMac(title, macStr, nullValid, mcastValid)
{
    var pattern          = /^\s*([A-Fa-f0-9]{2}\-){5}[A-Fa-f0-9]{2}\s*$/;
    var patternMulti     = /^\s*[0-9A-Fa-f]{1}[13579bdfBDF]{1}(\-[A-Fa-f0-9]{2}){5}\s*$/;
    var patternBroadcast = /^\s*(((FF)|(ff))\-){5}((FF)|(ff)){1}\s*$/;
    var patternZero      = /^\s*(((00)|(00))\-){5}((00)|(00)){1}\s*$/;
    var flag;
    var errorMsg;

    if ( 0 == macStr.length )
    {
        if( !nullValid )
        {
            errorMsg = "Please input MAC address.";
            return errorMsg;
        }
        else
        {
            return '';
        }
    }

    flag = pattern.test(macStr);
    if(!flag)
    {
        errorMsg = "The input " + title + " is invalid.";
        return errorMsg;
    }

    flag = patternBroadcast.test(macStr);
    if(flag)
    {
        errorMsg = "The input " + title + " is invalid(Broadcast MAC).";
        return errorMsg;
    }

    flag = patternMulti.test(macStr);
    if(flag&&(false == mcastValid))
    {
        errorMsg = "The input " + title + " is invalid(Multicast MAC).";
        return errorMsg;
    }

    flag = patternZero.test(macStr);
    if(flag)
    {
        errorMsg = "The input " + title + " is invalid(All zero MAC).";
        return errorMsg;
    }
    return '';
}

function checkInputOui(title, ouiStr, nullValid)
{
    var pattern          = /^\s*([A-Fa-f0-9]{2}\-){2}[A-Fa-f0-9]{2}\s*$/;
    var patternZero      = /^\s*(((00)|(00))\-){2}((00)|(00)){1}\s*$/;
    var flag;
    var errorMsg;

    if ( 0 == ouiStr.length )
    {
        if( !nullValid )
        {
            errorMsg = "Please input OUI.";
            return errorMsg;
        }
        else
        {
            return '';
        }
    }

    flag = pattern.test(ouiStr);
    if(!flag)
    {
        errorMsg = "The input " + title + " is invalid.";
        return errorMsg;
    }

    flag = patternZero.test(ouiStr);
    if(flag)
    {
        errorMsg = "The input " + title + " is invalid(All zero OUI).";
        return errorMsg;
    }
    return '';
}

/***********************
 *   other functions   *
 ***********************/
function objDisable(id)
{
  var obj = mainIframe.document.getElementById(id);

  if (obj)
    obj.disabled = true;
}

function objEnable(id)
{
  var obj = mainIframe.document.getElementById(id);

  if (obj)
    obj.disabled = false;
}

submitForm = function(obj)
{
  if (obj.checkFun != null)
  {
    var checkFunStr = "mainIframe."+ obj.checkFun;

    if (!eval(checkFunStr))
    {
      return;
    }
  }

/*--#STATIC--*/
  var contentStr = '';

  for (var i = 0; obj.hiddenArr[i] != null; i++)
  {
    contentStr += obj.hiddenArr[i][0] + '=' + obj.hiddenArr[i][1] + '&';
  }

  for (var i = 0; i < obj.sendNum; i++)
  {
    contentStr += obj.sendArr[i][0] + '=' + obj.sendArr[i][1] + '&';
  }

  contentStr += 'submitEnd=0';

  alert(contentStr);
  obj.clearSendArr();
/*--#ENDSTATIC--*/

/*--#DYNAMIC>
  var str = '<form name="'+ obj.formId +'" id="'+ obj.formId +'" method="post" action="'+ obj.actionUrl +'">';

  for (var i = 0; obj.hiddenArr[i] != null; i++)
  {
    str += drawInputHidden(obj.hiddenArr[i][0], obj.hiddenArr[i][1]);
  }

  for (var i = 0; i < obj.sendNum; i++)
  {
    str += drawInputHidden(obj.sendArr[i][0], obj.sendArr[i][1]);
  }

  str += drawInputHidden('submitEnd', '0');
  str += '<\/form>';

  mainIframe.document.getElementById(obj.divId).innerHTML = str;
  mainIframe.document.getElementById(obj.formId).submit();
*//*#ENDDYNAMIC*/
}

function changeCheck(checkId, status)
{
  var obj = mainIframe.document.getElementById(checkId);

  if (obj)
  {
  	if (obj.disabled)
  	{
  		/* ignore */
  		return;
  	}
  	
    if ((status == true) || (status == 1) || (status == 'Enabled'))
    {
      obj.checked = true;
    }
    else if ((status == false) || (status == 0) || (status == 'Disabled'))
    {
      obj.checked = false;
    }
    else
    {
      /* do nothing */
    }
  }
}

function buildIfList( portlist, trunklist )
{
    var ifList;

    if( portlist != '' && trunklist != '')
    {
        ifList = portlist+'?'+trunklist;
    }
    else if(trunklist != '')
    {
        ifList = trunklist;
    }
    else
    {
        ifList = portlist;
    }

    return ifList;
}

