/* 
 * Copyright (c) 2012 Qualcomm Atheros, Inc.. 
 * All Rights Reserved. 
 * Qualcomm Atheros Confidential and Proprietary. 
 */
 
/* create table */
function createFormTable(id, title, rowMax, actionUrl, checkFun, tableType)
{
  this.id = id;
  this.title = title;
  this.divId = id + 'Div';

  /* table parameters */
  this.tableId = id + 'Table';
  this.rowMax = rowMax;
  this.titleRow;
  this.rowArr = new Array();
  this.rowNum = 0;
  this.colAttribute = new Array();

  /* form parameters */
  this.formId = id+'Form';
  this.actionUrl = actionUrl;
  this.checkFun = checkFun;
  this.sendArr = new Array();
  this.sendNum = 0;
  this.needSent = false;
  this.tableType = tableType;
  this.hiddenArr = new Array();
  this.hiddenNum = 0;
  this.hiddenArr[this.hiddenNum++] = ['submitId', id];

  if (rowMax <= 128)
  {
    this.rowNumPerPage = 10;
  }
  else if (rowMax <= 1024)
  {
    this.rowNumPerPage = 50;
  }
  else
  {
    this.rowNumPerPage = 200;
  }

  this.defineTitle = function(titleEntry)
  {
    this.titleRow = titleEntry;
  }

  this.defineColAttribute = function(colAttribute)
  {
    this.colAttribute = colAttribute;
  }

  this.defineRow = function(rowEntry)
  {
    this.rowArr[this.rowNum++] = rowEntry;
  }

  this.alertAllRows = function()
  {
    for (i=0;i<this.rowNum;i++)
    {
      alert(this.rowArr[i]);
    }
  }

  this.changeAllCheck = function(obj)
  {
    for (var i = 0; i < this.rowNum; i++)
    {
      changeCheck('chk'+i, obj.checked);
    }
  }

  this.drawTitle = function()
  {
    var str = '';
    var innArr = this.titleRow.split('?');

    str += '<tr>';

    if (this.tableType == 'delete')
    {
      var allCheckChangeFun = this.id + '.changeAllCheck(this)';
      str += '<th width="5%">';
      str += drawCheckBox('allChk', '', 0, allCheckChangeFun);
      str += '<\/th>';
    }

    for (var i = 0; innArr[i] != null; i++)
    {
      str += '<th>'+ innArr[i] +'<\/th>';
    }

    str += '<\/tr>';

    return str;
  }

  this.drawDiv = function()
  {
    return '<div id="' + this.divId + '"><\/div>';
  }

  this.drawTable = function()
  {
    var str = '<div class="listSection" id="'+ this.id +'">';
    str += '<h4>'+ this.title +'<\/h4>';
    if (this.rowMax)
    {
    	str += '<span class="note">Max: '+ this.rowMax +'<\/span>';
    }
    str += '<span class="note">Total: '+ this.rowNum +'<\/span>';
    str += '<div id="'+ this.id +'Section'+ id +'">';
    str += '<table class="list">';
    str += this.drawTitle();

    /* data indexDataMax loop */
   	var rowMaxTemp = this.rowMax || 65535;
   	var counterMaxTemp = 10;
    for (var j = 0; j < rowMaxTemp; j++)
    {
      if (this.rowArr[j] != null)
      {
        var innArr = this.rowArr[j].split('?');

        str += '<tr>';

        if (this.tableType == 'delete')
        {
          str += '<td>';
          str += drawCheckBox('chk' + j, '', 0);
          str += '<\/td>';
        }

        for (var n = 0; innArr[n] != null; n++)
        {
          str += '<td>'+ innArr[n] +'<\/td>';
        }

        str += '<\/tr>';
      }
      else
      {
      	if ((counterMaxTemp --) <= 0)
      	{
      		break;
      	}
      }
    }

    str += '<\/table><\/div>';
    return str;
  }

  this.drawButton = function()
  {
    return drawButtons(this.id, this.tableType);
  }

  this.submitForm = function()
  {
    submitForm(this);
  }

  this.clearSendArr = function()
  {
    //this.sendArr = new Array();
    this.sendNum = 0;
    this.needSent = false;
  }

  this.checkNeedSent = function()
  {
    if (this.needSent == false)
    {
      alert('Configuration not be changed.');
      return false;
    }

    return true;
  }

}


