/* * Copyright (c) 2012 Qualcomm Atheros, Inc.
 * All Rights Reserved. 
 *Qualcomm Atheros Confidential and Proprietary. 
 *Notifications and licenses are retained for attribution purposes only */
/*
 * Copyright 2001 MontaVista Software Inc.
 * Author: Jun Sun, jsun@mvista.com or jsun@junsun.net
 * Copyright (C) 2000, 2001 Ralf Baechle (ralf@gnu.org)
 *
 * Copyright (C) 2007 Lemote Inc. & Insititute of Computing Technology
 * Author: Fuxin Zhang, zhangfx@lemote.com
 *
 *  This program is free software; you can redistribute  it and/or modify it
 *  under  the terms of  the GNU General  Public License as published by the
 *  Free Software Foundation;  either version 2 of the  License, or (at your
 *  option) any later version.
 *
 *  THIS  SOFTWARE  IS PROVIDED   ``AS  IS'' AND   ANY  EXPRESS OR IMPLIED
 *  WARRANTIES,   INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF
 *  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
 *  NO  EVENT  SHALL   THE AUTHOR  BE    LIABLE FOR ANY   DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 *  NOT LIMITED   TO, PROCUREMENT OF  SUBSTITUTE GOODS  OR SERVICES; LOSS OF
 *  USE, DATA,  OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 *  ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR TORT
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 *  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *  You should have received a copy of the  GNU General Public License along
 *  with this program; if not, write  to the Free Software Foundation, Inc.,
 *  675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */
#ifndef _SERIAL_H_
#define _SERIAL_H_

#ifdef __cplusplus
extern "C" {
#endif    /* __cplusplus */




//#define CONFIG_BAUDRATE 115200
#define CONFIG_BAUDRATE 9600

#define ATH_S124_UART1_BASE  0x18060000
#define ATH_S124_UART2_BASE  0x18070000
#define AR_UART_BASE         ATH_S124_UART1_BASE

#define	REG_OFFSET		     4
/* register offset */
#define OFS_RCV_BUFFER		(0*REG_OFFSET)
#define OFS_TRANS_HOLD		(0*REG_OFFSET)
#define OFS_SEND_BUFFER		(0*REG_OFFSET)
#define OFS_INTR_ENABLE		(1*REG_OFFSET)
#define OFS_INTR_ID		    (2*REG_OFFSET)
#define OFS_FIFO_CONTROL    (2*REG_OFFSET)
#define OFS_DATA_FORMAT		(3*REG_OFFSET)
#define OFS_LINE_CONTROL	(3*REG_OFFSET)
#define OFS_MODEM_CONTROL	(4*REG_OFFSET)
#define OFS_RS232_OUTPUT	(4*REG_OFFSET)
#define OFS_LINE_STATUS		(5*REG_OFFSET)
#define OFS_MODEM_STATUS	(6*REG_OFFSET)
#define OFS_RS232_INPUT		(6*REG_OFFSET)
#define OFS_SCRATCH_PAD		(7*REG_OFFSET)

#define OFS_DIVISOR_LSB		(0*REG_OFFSET)
#define OFS_DIVISOR_MSB		(1*REG_OFFSET)

//#define     SERIAL_CLOCK_FREQ       25000000


#define UART16550_READ(y)	    music_reg_rd((AR_UART_BASE+(y)))
#define UART16550_WRITE(x, z)	music_reg_wr((AR_UART_BASE+(x)), (z))


#ifdef __cplusplus
}
#endif    /* __cplusplus */

#endif                          /* _SERIAL_API_H_ */
