/* 
 * Copyright (c) 2012 Qualcomm Atheros, Inc.. 
 * All Rights Reserved. 
 * Qualcomm Atheros Confidential and Proprietary. 
 */

#include <common.h>


//#define ASIC_CPU_CLOCK (300 * 1000 * 1000)
#define ASIC_CPU_CLOCK (533 * 1000 * 1000)
#define FPGA_CPU_CLOCK (50 * 1000 * 1000)

int soc_bus_freq_get(void);
//uint32_t mips_timer_count_per_second = ASIC_CPU_CLOCK/2;
static inline void mips_compare_set(unsigned long v)
{
    asm volatile ("mtc0 %0, $11"::"r" (v));
}

static inline void mips_count_set(unsigned long v)
{
    asm volatile ("mtc0 %0, $9"::"r" (v));
}

inline uint32_t mips_count_get(void)
{
    uint32_t count;

    asm volatile ("mfc0 %0, $9":"=r" (count):);
    return count;
}

static inline void mips_cp0_barrier(void)
{
    asm volatile ("ehb");
}

void udelay(uint32_t usec)
{
    uint32_t tmo, start;
    mips_compare_set(0);
    mips_count_set(0);
    mips_cp0_barrier();
    start = mips_count_get();

    //tmo = usec * (mips_timer_count_per_second / 1000000);
    tmo = usec * (soc_bus_freq_get() / 1000000);
    while ((uint32_t) ((mips_count_get() - start)) < tmo);
}
