/*
 * Copyright (c) 2012 Qualcomm Atheros, Inc..
 * All Rights Reserved.
 * Qualcomm Atheros Confidential and Proprietary.
 */

#include <stdio.h>

#include "contiki.h"

#include "elite_init.h"
#include "webserver-nogui.h"
#include "music_upgrade.h"
#include "watchdog.h"
#include "cfg_file.h"

int serial_init();
void music_spi_init();

#if LOG_CONF_ENABLED
void log_message(char *str1, char *str2)
{
    printf("%s %s\n", str1, str2);
}
#endif

PROCESS_NAME(music_gmac_process);
PROCESS_NAME(watchdog_process);
PROCESS_NAME(device_process);

int main(void)
{
    /* hardware init */
    serial_init();

    printf("\r\n*************************\r\n");
    printf("start watchdog_init\r\n");
    watchdog_init();
    watchdog_start();

    printf("start clock_init\r\n");
    clock_init();

    printf("start music_spi_init\r\n");
    music_spi_init();
    board_get_partition_info();

    printf("start elite_switch_init\r\n");
    elite_switch_init();

    /* process init */
    printf("start process_init\r\n");
    process_init();

    printf("process: starting '%s'\r\n", PROCESS_NAME_STRING(&etimer_process));
    process_start(&etimer_process, NULL);

    printf("process: starting '%s'\r\n", PROCESS_NAME_STRING(&tcpip_process));
    process_start(&tcpip_process, NULL);

    printf("process: starting '%s'\r\n", PROCESS_NAME_STRING(&webserver_nogui_process));
    process_start(&webserver_nogui_process, NULL);

    printf("process: starting '%s'\r\n", PROCESS_NAME_STRING(&watchdog_process));
    process_start(&watchdog_process, NULL);

    printf("process: starting '%s'\r\n", PROCESS_NAME_STRING(&device_process));
    process_start(&device_process, NULL);

    printf("start cfg_file_provision\r\n");
    cfg_file_provision();

    printf("process: starting '%s'\r\n", PROCESS_NAME_STRING(&music_gmac_process));
    process_start(&music_gmac_process, NULL);

    image_upgrade_identification_check();
    show_image_info();

    printf("into Main scheduler loop\r\n");
    /* Main scheduler loop */
    while (1)
    {
        process_run();
        etimer_request_poll();
    }

    return 0;
}
